org.codehaus.groovy.classgen.asm

## Class StatementMetaTypeChooser

- java.lang.Object
- - org.codehaus.groovy.classgen.asm.StatementMetaTypeChooser

All Implemented Interfaces:
  TypeChooser

Direct Known Subclasses:
  StaticTypesTypeChooser

    public class StatementMetaTypeChooser
    extends java.lang.Object
    implements TypeChooser

A `TypeChooser` which is aware of statement metadata.

### Constructor Summary

Constructors
Constructor and Description
`StatementMetaTypeChooser()`

### Method Summary

Methods
`ClassNode` `resolveType(Expression exp, ClassNode current)` Resolve the type of an expression.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### StatementMetaTypeChooser

    public StatementMetaTypeChooser()

### Method Detail

#### resolveType

    public ClassNode resolveType(Expression exp,
                        ClassNode current)

Description copied from interface: `TypeChooser`
Resolve the type of an expression. Depending on the implementations, the returned type may be the declared type or an inferred type.

Specified by:
  `resolveType` in interface `TypeChooser`
Parameters:
  `exp` - the expression for which the type must be returned.
  `current` - the classnode this expression belongs to
Returns:
  the resolved type.